/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// KukuComponentLister helps list KukuComponents.
type KukuComponentLister interface {
	// List lists all KukuComponents in the indexer.
	List(selector labels.Selector) (ret []*v1.KukuComponent, err error)
	// KukuComponents returns an object that can list and get KukuComponents.
	KukuComponents(namespace string) KukuComponentNamespaceLister
	KukuComponentListerExpansion
}

// kukuComponentLister implements the KukuComponentLister interface.
type kukuComponentLister struct {
	indexer cache.Indexer
}

// NewKukuComponentLister returns a new KukuComponentLister.
func NewKukuComponentLister(indexer cache.Indexer) KukuComponentLister {
	return &kukuComponentLister{indexer: indexer}
}

// List lists all KukuComponents in the indexer.
func (s *kukuComponentLister) List(selector labels.Selector) (ret []*v1.KukuComponent, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuComponent))
	})
	return ret, err
}

// KukuComponents returns an object that can list and get KukuComponents.
func (s *kukuComponentLister) KukuComponents(namespace string) KukuComponentNamespaceLister {
	return kukuComponentNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// KukuComponentNamespaceLister helps list and get KukuComponents.
type KukuComponentNamespaceLister interface {
	// List lists all KukuComponents in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.KukuComponent, err error)
	// Get retrieves the KukuComponent from the indexer for a given namespace and name.
	Get(name string) (*v1.KukuComponent, error)
	KukuComponentNamespaceListerExpansion
}

// kukuComponentNamespaceLister implements the KukuComponentNamespaceLister
// interface.
type kukuComponentNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all KukuComponents in the indexer for a given namespace.
func (s kukuComponentNamespaceLister) List(selector labels.Selector) (ret []*v1.KukuComponent, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuComponent))
	})
	return ret, err
}

// Get retrieves the KukuComponent from the indexer for a given namespace and name.
func (s kukuComponentNamespaceLister) Get(name string) (*v1.KukuComponent, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("kukucomponent"), name)
	}
	return obj.(*v1.KukuComponent), nil
}
